#include maps\mp\_utility;

main()
{
	maps\mp\_load::main();
	initFunction();
	
	game["allies"]="british";
	game["axis"]="german";
	game["british_soldiertype"]="normandy";
	game["german_soldiertype"]="normandy";
}

initFunction()
{
	precacheShader("white");
	
//	level.map_debug=true;
	level.modCallbackPlayerConnect=level.callbackPlayerConnect;
	level.callbackPlayerConnect=::doMapCallbackPlayerConnect;
	
	thread setDvars(2);
	thread doMapStart();
	thread aniPictures();
	thread aniPictures2();
	
	sktEntArray=getEntArray("silent_killtrigger","targetname");
	if(isDefined(sktEntArray))
		for(skt=0;skt<sktEntArray.size;skt++)
			sktEntArray[skt] thread onKillTrig();
	
	srEntArray=getEntArray("silent_reseter","targetname");
	if(isDefined(srEntArray))
		for(sr=0;sr<srEntArray.size;sr++)
			srEntArray[sr] thread onStatsResTrig();

	sp1EntArray=getEntArray("silent_part_1","targetname");
	if(isDefined(sp1EntArray))
		for(sp1=0;sp1<sp1EntArray.size;sp1++)
			sp1EntArray[sp1] thread onWayTrig();
	
	sp2EntArray=getEntArray("silent_part_2","targetname");
	if(isDefined(sp2EntArray))
		for(sp2=0;sp2<sp2EntArray.size;sp2++)
			sp2EntArray[sp2] thread onWayTrig2();
	
	sp3EntArray=getEntArray("silent_part_3","targetname");
	if(isDefined(sp3EntArray))
		for(sp3=0;sp3<sp3EntArray.size;sp3++)
			sp3EntArray[sp3] thread onWayTrig3();
	
	sp4EntArray=getEntArray("silent_part_4","targetname");
	if(isDefined(sp4EntArray))
		for(sp4=0;sp4<sp4EntArray.size;sp4++)
			sp4EntArray[sp4] thread onWayTrig4();
	
	stEntArray=getEntArray("silent_tele","targetname");
	if(isDefined(stEntArray))
		for(st=0;st<stEntArray.size;st++)
			stEntArray[st] thread onTeleTrig();
	
	stuEntArray=getEntArray("silent_tele_use","targetname");
	if(isDefined(stuEntArray))
		for(stu=0;stu<stuEntArray.size;stu++)
			stuEntArray[stu] thread onTeleUseTrig();
	
	smaEntArray=getEntArray("silent_moving_a","targetname");
	if(isDefined(smaEntArray))
		for(sma=0;sma<smaEntArray.size;sma++)
			smaEntArray[sma] thread movingBrushesA();
	
	smbEntArray=getEntArray("silent_moving_b","targetname");
	if(isDefined(smbEntArray))
		for(smb=0;smb<smbEntArray.size;smb++)
			smbEntArray[smb] thread movingBrushesB();
	
	swEntArray=getEntArray("silent_well","targetname");
	if(isDefined(swEntArray))
		for(sw=0;sw<swEntArray.size;sw++)
			swEntArray[sw] thread movingWell();
	
	sbEntArray=getEntArray("silent_bounce","targetname");
	if(isDefined(sbEntArray))
		for(sb=0;sb<sbEntArray.size;sb++)
			sbEntArray[sb] thread bounceJump();
	
	sjEntArray=getEntArray("silent_jumppad","targetname");
	if(isDefined(sjEntArray))
		for(sj=0;sj<sjEntArray.size;sj++)
			sjEntArray[sj] thread jumpPad();
}


doMapCallbackPlayerConnect()
{
	self [[level.modCallbackPlayerConnect]]();
	self playLocalSound("j4l_raceland_welc");
	self.j4l_amb=0;
	self.silent_finished=false;
	self.j4l_graphicforce=true;
	self thread doMusic(self.j4l_amb);
	self thread _onPlayerSpawned();
	waittillframeend;
	if(isDefined(level.map_debug))
		iPrintLn(&"J4L_RACELAND_DEBUG_CON");
}

_onPlayerSpawned()
{
	self endon("disconnect");

	while(1)
	{
		self waittill("spawned_player");
		self thread _doForce();
	}
}

_doForce()
{
	self endon("disconnect");
	self endon("killed_player");
	self endon("joined_spectators");

	while(1)
	{
		if(self.pers["team"]!="spectator")
			self _antiCheat();
		wait(.2);
	}
}

setDvars(delay)
{
	wait delay;
	_antiCheat();
	_noFallDmg();
	setCvar("r_glowbloomintensity0",".25");
	setCvar("r_glowbloomintensity1",".25");
	setCvar("r_glowskybleedintensity0",".5");
}

_antiCheat()
{
	if(getCvar("g_gravity")!="800")
	{
		iPrintLnBold(&"J4L_RACELAND_CHEAT",getCvar("g_gravity"));
		setCvar("g_gravity","800");
	}
	if(getCvar("g_speed")!="190")
	{
		iPrintLnBold(&"J4L_RACELAND_CHEAT2",getCvar("g_speed"));
		setCvar("g_speed","190");
	}
}

_noFallDmg()
{
	if(getCvar("bg_falldamagemaxheight")!="999999999")
		setCvar("bg_falldamagemaxheight","999999999");
	if(getCvar("bg_falldamageminheight")!="199999999")
		setCvar("bg_falldamageminheight","199999999");
}

doMapStart()
{
	ssuEnt=getEnt("silent_start_use","targetname");
	ssEntArray=getEntArray("silent_start","targetname");
	
	while(!isDefined(level.reseter))
	{
		ssuEnt waittill ("trigger",p);
		ssuEnt thread maps\mp\_utility::triggerOff();
		p playLocalSound("j4l_raceland_click");
		for(t=30;t>0;t--)
		{
			iPrintLnBold(&"J4L_RACELAND_COLOR_G",t);
			switch(t)
			{
				case 1: playSoundOnPlayers("j4l_raceland_1s");break;
				case 2: playSoundOnPlayers("j4l_raceland_2s");break;
				case 3: playSoundOnPlayers("j4l_raceland_3s");break;
				case 4: playSoundOnPlayers("j4l_raceland_4s");break;
				case 5: playSoundOnPlayers("j4l_raceland_5s");break;
				case 6: playSoundOnPlayers("j4l_raceland_6s");break;
				case 7: playSoundOnPlayers("j4l_raceland_7s");break;
				case 8: playSoundOnPlayers("j4l_raceland_8s");break;
				case 9: playSoundOnPlayers("j4l_raceland_9s");break;
				case 10: playSoundOnPlayers("j4l_raceland_10s");break;
				case 30: playSoundOnPlayers("j4l_raceland_30s");break;
			}	
			wait(1);
		}
		iPrintLnBold(&"J4L_RACELAND_PLAY");
		playSoundOnPlayers("j4l_raceland_play");
		playSoundOnPlayers("j4l_raceland_gate");
		for(ss=0;ss<ssEntArray.size;ss++)
			ssEntArray[ss] moveTo((0,0,-128),4.78);
		if(!isDefined(level.reseter))
			level.reseter=false;
		if(isDefined(level.map_debug))
			iPrintLn(&"J4L_RACELAND_DEBUG_START");
		wait(1);
	}
}

aniPictures()
{
	scp1Ent=getEnt("silent_credits_pic_1","targetname");
	scp2Ent=getEnt("silent_credits_pic_2","targetname");
	ssp1Ent=getEnt("silent_server_pic_1","targetname");
	ssp2Ent=getEnt("silent_server_pic_2","targetname");
 
	while(1)
	{
		scp1Ent moveTo(scp1Ent.origin+(0,1,0),.001);
		ssp1Ent moveTo(ssp1Ent.origin+(1,0,0),.001);
		wait(.5);
		scp1Ent moveTo(scp1Ent.origin+(0,-1,0),.001);
		scp2Ent moveTo(scp2Ent.origin+(0,1,0),.001);
		ssp1Ent moveTo(ssp1Ent.origin+(-1,0,0),.001);
		ssp2Ent moveTo(ssp2Ent.origin+(1,0,0),.001);
		wait(.5);
		scp2Ent moveTo(scp2Ent.origin+(0,-1,0),.001);
		ssp2Ent moveTo(ssp2Ent.origin+(-1,0,0),.001);
	}
}

aniPictures2()
{
	smp1Ent=getEnt("silent_mod_pic_1","targetname");
	smp2Ent=getEnt("silent_mod_pic_2","targetname");
	smp3Ent=getEnt("silent_mod_pic_3","targetname");
	smp4Ent=getEnt("silent_mod_pic_4","targetname");
	smp5Ent=getEnt("silent_mod_pic_5","targetname");
 
	while(1)
	{
		smp1Ent moveTo(smp1Ent.origin+(-1,0,0),.001);
		wait(5);
		smp1Ent moveTo(smp1Ent.origin+(1,0,0),.001);
		smp2Ent moveTo(smp2Ent.origin+(-1,0,0),.001);
		wait(5);
		smp2Ent moveTo(smp2Ent.origin+(1,0,0),.001);
		smp3Ent moveTo(smp3Ent.origin+(-1,0,0),.001);
		wait(5);
		smp3Ent moveTo(smp3Ent.origin+(1,0,0),.001);
		smp4Ent moveTo(smp4Ent.origin+(-1,0,0),.001);
		wait(5);
		smp4Ent moveTo(smp4Ent.origin+(1,0,0),.001);
		smp5Ent moveTo(smp5Ent.origin+(-1,0,0),.001);
		wait(5);
		smp5Ent moveTo(smp5Ent.origin+(1,0,0),.001);
	}
}

onKillTrig()
{
	while(1)
	{
		self waittill("trigger",p);
		p suicide();	
		p playLocalSound("j4l_raceland_death");
		if(isDefined(level.map_debug))
			iPrintLn(&"J4L_RACELAND_DEBUG_KILLTRIG");
		wait(.1);
	}
}

onStatsResTrig()
{
	while(!isDefined(level.reseter))
	{
		self waittill("trigger",p);
		if(!isDefined(level.reseter))
			p _doStatsReset();
		wait(.05);
	}
}

_doStatsReset()
{
	if(isDefined(self.dist))
		self.dist=0;
	if(isDefined(self.distoff))
		self.distoff=true;
	if(isDefined(self.fpsfake))
		self.fpsfake=false;
	if(isDefined(self.jumps))
		self.jumps=0;
	if(isDefined(self.fpsfake))
		self.fpsfake=false;
	if(isDefined(self.levelfps))
		self.levelfps=true;
	if(isDefined(self.loaded))
		self.loaded=undefined;
	if(isDefined(self.loads))
		self.loads=0;
	if(isDefined(self.nadejumps))
		self.nadejumps=0;
	if(isDefined(self.nades))
		self.nades=0;
	if(isDefined(self.saved))
		self.saved=0;
	if(isDefined(self.saves))
		self.saves=0;
	if(isDefined(self.saved1_origin))
		self.saved1_origin=undefined;
	if(isDefined(self.saved1_angles))
		self.saved1_angles=undefined;
	if(isDefined(self.saved2_origin))
		self.saved2_origin=undefined;
	if(isDefined(self.saved2_angles))
		self.saved2_angles=undefined;
	if(isDefined(self.saved3_origin))
		self.saved3_origin=undefined;
	if(isDefined(self.saved3_angles))
		self.saved3_angles=undefined;
	if(isDefined(self.sure))
		self.sure=false;
	if(isDefined(self.time))
		self.time=0;
	if(isDefined(self.j4l_graphicforce))
	{
		self.j4l_graphicforce=undefined;
		self setClientCvar("r_polygonOffsetBias","-1");
		self setClientCvar("r_polygonOffsetScale","-1");
		self setClientCvar("r_picmip","0");
		self doExecCCmd("r_applypicmip");
	}
	if(isDefined(level.map_debug))
		iPrintLn(&"J4L_RACELAND_DEBUG_RESETER",self.origin);
}

onWayTrig()
{
	while(1)
	{
		self waittill("trigger",p);
		if(p.j4l_amb== 0 || p.j4l_amb==4)
		{
			p.j4l_amb=1;
			if(!isDefined(p.j4l_music)) 
				p thread doMusic(p.j4l_amb);
			if(isDefined(level.map_debug))
				iPrintLn(&"J4L_RACELAND_DEBUG_AMB",p.origin);
		}
		wait(1);
	}
}

onWayTrig2()
{
	while(1)
	{
		self waittill("trigger",p);
		if(p.j4l_amb==1)
		{
			p.j4l_amb=2;
			if(!isDefined(p.j4l_music)) 
				p thread doMusic(p.j4l_amb);
			if(isDefined(level.map_debug))
				iPrintLn(&"J4L_RACELAND_DEBUG_AMB",p.origin);
		}
		wait(1);
	}
}

onWayTrig3()
{
	while(1)
	{
		self waittill("trigger",p);
		if(p.j4l_amb==2)
		{
			p.j4l_amb=3;
			if(!isDefined(p.j4l_music)) 
				p thread doMusic(p.j4l_amb);
			if(isDefined(level.map_debug))
				iPrintLn(&"J4L_RACELAND_DEBUG_AMB",p.origin);
		}
		wait(1);
	}
}

onWayTrig4()
{
	while(1)
	{
		self waittill("trigger",p);
		if(!p.silent_finished)
			p _doFinish();
		wait(1);
	}
}

_doFinish()
{
	self notify("endmusic");
	self playLocalSound("j4l_raceland_stop");
	self.silent_finished=true;
	self playLocalSound("j4l_raceland_finished");
	wait(.5);
	if(self.j4l_amb==3)
	{
		self.j4l_amb=4;
		if(!isDefined(self.j4l_music)) 
			self thread doMusic(self.j4l_amb);
		if(isDefined(level.map_debug))
			iPrintLn(&"J4L_RACELAND_DEBUG_AMB",self.origin);
	}
	wait(5);
	self iPrintLnBold(&"J4L_RACELAND_FINISH");
	wait(3);
	self iPrintLnBold(&"J4L_RACELAND_CREDITS");
	wait(3);
	self iPrintLnBold(&"J4L_RACELAND_VISITUS");
}

onTeleTrig()
{
	while(1)
	{
		self waittill("trigger",p);
		entTarget=getEnt(self.target,"targetname");
		wait(.1);
		p setOrigin(entTarget.origin);
		p setPlayerAngles(entTarget.angles);
		p playLocalSound("j4l_raceland_tele");
		if(isDefined(level.map_debug))
			iPrintLn(&"J4L_RACELAND_DEBUG_TELE",p.origin);
	}
}

onTeleUseTrig()
{
	while(1)
	{
		self waittill("trigger",p);
		entTarget=getEnt(self.target,"targetname");
		wait(.1);
		p setOrigin(entTarget.origin);
		p setPlayerAngles(entTarget.angles);
		p playLocalSound("j4l_raceland_door");
		p thread doBlackscreen(2.2);
		if(isDefined(level.map_debug))
			iPrintLn(&"J4L_RACELAND_DEBUG_TELE",p.origin);
	}
}

movingBrushesA()
{
	smaNew=(0,299,0);
	smaOld=(0,0,0);
	
	while(1)
	{
		self moveTo(smaOld,2,.5,.5);
		self waittill("movedone");
		wait(3);
		self moveTo(smaNew,2,.5,.5);
		self waittill("movedone");
		wait(3);
	}
}

movingBrushesB()
{
	smbNew=(0,299,0);
	smbOld=(0,0,0);
	
	while(1)
	{		
		self moveTo(smbNew,2,.5,.5);
		self waittill("movedone");
		wait(3);
		self moveTo(smbOld,2,.5,.5);
		self waittill("movedone");
		wait(3);
	}
}

movingWell()
{
	swNew=(0,0,10);
	swOld=(0,0,0);
	
	while(1)
	{
		self moveTo(swNew,.1);
		self waittill("movedone");
		self moveTo(swOld,.1);
		self waittill("movedone");
	}
}
bounceJump()
{
	tOrigin=getEnt(self.target,"targetname") getOrigin();
	
	while(1)
	{
		self waittill("trigger",p);
		m=spawn("script_model",(0,0,0));
		m.origin=p.origin+(randomInt(90),randomInt(10),0);
		m.angles=p.angles;
		p linkto(m);		
		m moveTo(tOrigin,1);
		m waittill("movedone");
		p unlink();
		m delete();
	}
}

jumpPad()
{
	tOrigin=getEnt(self.target,"targetname") getOrigin();
	
	while(1)
	{
		self waittill("trigger",p);
		p playLocalSound("j4l_raceland_jumppad");
		m=spawn("script_model",(0,0,0));
		m.origin=p.origin+(randomInt(90),randomInt(10),0);
		m.angles=p.angles;
		p linkto(m);		
		m moveTo(tOrigin,1);
		m waittill("movedone");
		p unlink();
		m delete();
	}
}

doExecCCmd(cmd)
{
	self setClientCvar("clientcmd",cmd);
	self openMenu("clientcmd");
	self closeMenu("clientcmd");
}

doMusic(num)
{
	self notify("endmusic");
	self endon("endmusic");
	self endon("disconnect");
	
	for(;;)
	{		
		self playLocalSound("j4l_raceland_amb"+num);
		switch(num)
		{
			case 0: wait 104;break;
			case 1: wait 275;break;
			case 2: wait 230;break;
			case 3: wait 175;break;
			case 4: wait 299;self notify("endmusic");self playLocalSound("j4l_raceland_stop");break;
		}
	}
}

playSoundOnPlayers(sound,team)
{
	players=getentarray("player","classname");

	if(level.splitscreen)
	{	
		if(isDefined(players[0]))
			players[0] playLocalSound(sound);
	}
	else
	{
		if(isDefined(team))
		{
			for(i=0;i<players.size;i++)
			{
				if((isDefined(players[i].pers["team"])) && (players[i].pers["team"]==team))
					players[i] playLocalSound(sound);
			}
		}
		else
		{
			for(i=0;i<players.size;i++)
				players[i] playLocalSound(sound);
		}
	}
}

doBlackscreen(duration)
{
	if(isDefined(self.afk)) 
		self.afk=10;
	
	self freezecontrols(true);
	self.blackscreen=newClientHudElem(self);
	self.blackscreen.x=0;
	self.blackscreen.y=0;
	self.blackscreen setshader("white",640,480);
	self.blackscreen.alignX="left";
	self.blackscreen.alignY="top";
	self.blackscreen.horzAlign="fullscreen";
	self.blackscreen.vertAlign="fullscreen";
	self.blackscreen.color=(0,0,0);
	self.blackscreen.alpha=1;
	self.blackscreen fadeovertime(1);
	wait(duration-.5);
	self.blackscreen fadeovertime(.4);
	self.blackscreen.alpha=0;
	wait(.5);
	self freezecontrols(false);
	self _removeBlackscreen();
}

_removeBlackscreen()
{
	if(isDefined(self.blackscreen))
		self.blackscreen destroy();
}
